#ifndef _NEWCAPS_CAPABILITY_H
#define _NEWCAPS_CAPABILITY_H

#include <inttypes.h>
#include <sys/types.h>

#define _LINUX_CAPABILITY_VERSION  0x20060903

#define CAP_CHOWN             0

#define CAP_REG_FORK         32
#define CAP_REG_OPEN         33
#define CAP_REG_EXEC         34
#define CAP_REG_SXID         35
#define CAP_REG_WRITE        36
#define CAP_REG_PTRACE       37

#define CAP_REGULAR_SET 0x0000ffff00000000ULL
#define CAP_FULL_SET 0xffffffffffffffffULL

typedef struct user_cap_header_struct {
        uint32_t version;
        pid_t pid;
} *cap_user_header_t;

typedef struct user_cap_data_struct {
        uint64_t effective;
        uint64_t permitted;
        uint64_t inheritable;
} *cap_user_data_t;

long capget (cap_user_header_t header, cap_user_data_t dataptr);

long capset (cap_user_header_t header, cap_user_data_t dataptr);

#endif
