#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>
#include <fcntl.h>

#include "capability.h"
#include "testsuite.h"

int
main (int argc, char *argv[])
{
  uint64_t prm, eff, inh;

  print_caps (&prm, &eff, &inh);
  if ( argc > 1 && strcmp (argv[1], "print") == 0 )
    return 0;
  PRINT_AND_DO (set_caps (prm, prm&~(1ULL<<CAP_REG_FORK), inh));
  print_caps (NULL, NULL, NULL);
  printf ("trying to fork()...\n");
  if ( fork () != -1 )
    {
      printf ("succeeded when it should have failed!\n");
      exit (EXIT_FAILURE);
    }
  printf ("good: %s\n", strerror(errno));
  PRINT_AND_DO (set_caps (prm, prm&~(1ULL<<CAP_REG_OPEN), inh));
  print_caps (NULL, NULL, NULL);
  printf ("trying to open()...\n");
  if ( open ("/etc/fstab", O_RDONLY) != -1 )
    {
      printf ("succeeded when it should have failed!\n");
      exit (EXIT_FAILURE);
    }
  printf ("good: %s\n", strerror(errno));
  PRINT_AND_DO (set_caps (prm, prm&~(1ULL<<CAP_REG_EXEC), inh));
  print_caps (NULL, NULL, NULL);
  printf ("trying to exec()...\n");
  execl (argv[0], argv[0], "print", NULL);
  printf ("good: %s\n", strerror(errno));
  return 0;
}
